package net.shipilev.singleton;

public class FactorySelector {

    public static final int type = Integer.getInteger("factoryType", 1);

    public static Factory newFactory() {
        switch (type) {
            case 1: return new SynchronizedFactory();
            case 2: return new NonVolatileDCLFactory();
            case 3: return new VolatileDCLFactory();
            case 4: return new HolderFactory();
            case 5: return new FinalWrapperDCLFactory();
            case 6: return new VolatileCacheDCLFactory();
            default:
                throw new IllegalStateException("Unknown type: " + type);
        }
    }

}
