package net.shipilev.singleton;

public class FinalWrapperDCLFactory implements Factory {

    private FinalWrapper instance;

    @Override
    public Singleton getInstance() {
        if (instance == null) {
            synchronized (this) {
                if (instance == null) {
                    instance = new FinalWrapper(SingletonSelector.newSingleton());
                }
            }
        }
        return instance.singleton;
    }

    private static class FinalWrapper {
        public final Singleton singleton;
        public FinalWrapper(Singleton singleton) {
            this.singleton = singleton;
        }
    }

}
