package net.shipilev.singleton;

public class SingletonSelector {

    public static final int type = Integer.getInteger("singletonType", 1);

    public static Singleton newSingleton() {
        switch (type) {
            case 1: return new UnsafeSingleton();
            case 2: return new SafeSingleton();
            case 3: return new TrickySingleton();
            default:
                throw new IllegalStateException("Unknown type: " + type);
        }
    }

}
