package net.shipilev.singleton;

public class VolatileCacheDCLFactory implements Factory {

    private volatile Singleton instance;

    @Override
    public Singleton getInstance() {
        Singleton res = instance;
        if (res == null) {
            synchronized (this) {
                if (instance == null) {
                    instance = SingletonSelector.newSingleton();
                }
            }
            return instance;
        }
        return res;
    }

}
