package net.shipilev.singleton;

public class VolatileDCLFactory implements Factory {

    private volatile Singleton instance;

    @Override
    public Singleton getInstance() {
        if (instance == null) {
            synchronized (this) {
                if (instance == null) {
                    instance = SingletonSelector.newSingleton();
                }
            }
        }
        return instance;
    }

}
